#!/usr/local/bin/perl
#--NetShopOwner-CGI-version:4.2.5.0--

;#
;# basket.cgi
;# [PC]J[g̒
;# Copyright (c) 2004- Increment P Corp. All rights reserved.
;#
;# 2009/09/30 NSO4Ή
;# last modified 2010/05/11 Y.motai SBPSϑΉ
;#

use strict;
use uselib;
use defnsopath_shop;
use NsoVersionPC 1.00;
use Design::TemplBasket;
use Lib::SiteStatus;
use Lib::Basket;
use Lib::ExpensesGoods;
use Lib::StockUtil;

&ReadParse();
my %in    = %main::in;
my %incfn = %main::incfn;
my %inct  = %main::inct;

# CX^X`
my $objConfigSystem = Config::NsoSystem->newShop();
my $objConfigMaster = Config::NsoMaster->new();
my $NsoMisc       = NsoMisc->new();
my $ExpensesGoods;

# RtBO[ṼLbV
my %ConfigSystem = $objConfigSystem->cache_config();
my %ConfigMaster = $objConfigMaster->cache_config();

my $status_err;

FUNC:{
	my $func = $in{func} || 'main';
	my %function = (
		main       => \&main,
		insert     => \&insert,
		update     => \&update,
		delete_one => \&delete_one,
		delete_all => \&delete_all,
		logout     => \&logout,
	);
	
	&check_order_finish;
	&check_closing();
	
	if ($function{$func}){
		$function{$func}->();
	}else{
		&main();
	}
}
exit();

;#
;# JXEXԌ
;#
sub check_closing {
	my $SiteStatus = Lib::SiteStatus->new({ ConfigSystem=>\%ConfigSystem });
	$SiteStatus->CheckClosing();
}

;#
;# C
;#
sub main {

	# iEoZ
	$ExpensesGoods = Lib::ExpensesGoods->new({ ConfigSystem=>\%ConfigSystem, ConfigMaster=>\%ConfigMaster });
	my $eg_err = $ExpensesGoods->ParseBasket();

	# G[bZ[W擾
	my $status_err_param = $in{ErrorStatus};
	$status_err .= &error_message( $status_err_param ) if ( $status_err_param );

	if($eg_err ne ""){
		$status_err .= $eg_err;
	}

	# VXeev[gNXCX^X
	my $TemplBasket  = Design::TemplBasket->new({ ConfigSystem=>\%ConfigSystem, ConfigMaster=>\%ConfigMaster, KickBack=>$in{KickBack}, ExpensesGoods=>$ExpensesGoods, status_err=>$status_err, insert=>$in{fc}, GoodsID=>$in{GoodsID} });
	
	# ue
	my $contents = $TemplBasket->RelpaceSystemTempl();
	
	# VXeev[gu
	print $NsoMisc->print_header();
	print $contents;
	exit();
}

;#
;# iǉ
;#
sub insert {
	my $Basket = Lib::Basket->new({ ConfigSystem=>\%ConfigSystem, ConfigMaster=>\%ConfigMaster });
	my %params = (
		CategoryID => $in{CategoryID},
		GoodsID    => $in{GoodsID},
		Units      => $in{Units},
		Variation1 => $in{Variation1},
		Variation2 => $in{Variation2},
		Variation3 => $in{Variation3},
		Variation4 => $in{Variation4},
		BackUrl    => $in{KickBack},
	);
	$status_err = $Basket->Insert(\%params);
	&main();
}

;#
;# iXV
;#
sub update {
	my $Basket = Lib::Basket->new({ ConfigSystem=>\%ConfigSystem, ConfigMaster=>\%ConfigMaster });
	my %params = (
		BasketID   => $in{BasketID},
		CategoryID => $in{CategoryID},
		GoodsID    => $in{GoodsID},
		Units      => $in{Units},
		Variation1 => $in{Variation1},
		Variation2 => $in{Variation2},
		Variation3 => $in{Variation3},
		Variation4 => $in{Variation4},
	);
	$status_err = $Basket->Update(\%params);
	&main();
}

;#
;# 1i폜
;#
sub delete_one {
	my $Basket = Lib::Basket->new({ ConfigSystem=>\%ConfigSystem, ConfigMaster=>\%ConfigMaster });
	my %params = (
		BasketID   => $in{BasketID},
	);
	$Basket->DeleteOne(\%params);
}

;#
;# Si폜
;#
sub delete_all {
	my $Basket = Lib::Basket->new({ ConfigSystem=>\%ConfigSystem, ConfigMaster=>\%ConfigMaster });
	my %params = ();
	$Basket->DeleteAll(\%params);
}

;#
;# iPCOSS`FbN
;#
sub check_order_finish {
	# IDNbL[ǂݎ
	require DB::NsoOrderIDDB;
	my $OrderIdDB = NsoOrderIDDB->new();
	my $OrderID   = $OrderIdDB->Read_OrderID();

	# IDNbL[cĂꍇ
	if ($OrderID ne ""){
		require Lib::IpcossCheck;
		my $IpcossCheck = Lib::IpcossCheck->new( {ConfigSystem=>\%ConfigSystem, ConfigMaster=>\%ConfigMaster, ExpensesGoods=>$ExpensesGoods} );
		# ipcoss ChecksB
		my $IpcCheckFlag = $IpcossCheck->check_ipcoss();
		# okng̏ꍇ̏
		if ($IpcCheckFlag eq 0){
			# ngƂ̏
			$IpcossCheck->ipcoss_ng();
		} else {
			# ok Ƃ̏
			my $contents = $IpcossCheck->RelpaceSystemTempl();
			print $NsoMisc->print_header();
			print $contents;
			exit ();
		}
	}
}

;#
;# OAEg
;#
sub logout {
	# OC폜
	require DB::NsoLoginTempDB;
	my $LoginTempDB = NsoLoginTempDB->new();
	$LoginTempDB->delete_no_lock();

	# OCpCookie폜
	$LoginTempDB->delete_cookie();
	
	# 폜
	require DB::NsoOrderTempDB;
	my $OrderTempDB = NsoOrderTempDB->new();
	$OrderTempDB->delete_no_lock();
	
	# pCookie폜
	$OrderTempDB->delete_cookie();
	
	&main();
}

;#
;# G[bZ[W擾
;#
sub error_message {

	my %ErrorMessageHash = (
		login_error						=> qq(<p>[AhX܂̓pX[hɌ肪܂B<br>悭m߂̏Ax͂ĂB</p>),
		logged_in_error					=> qq(<p>񂪌܂łB</p>),
		no_approval_member				=> qq(<p>܂Ao^FĂ܂BF܂ŁA΂炭҂B</p>),
		logged_in_no_approval_member	=> qq(<p>o^FĂ܂B</p>),
		logged_in						=> qq(<p>OCĂ炵΂炭Ԃo߁AOC̗L߂Ă܂B<br>萔łAxOCĂB</p>),
		no_member_service				=> qq(<p>݁AT[rX͎gpł܂B</p>),
		only_member_service				=> qq(<p>\\󂲂܂񂪁Aŵ͉qlɌ点ĂĂ܂B</p>),
		no_orderTemp					=> qq(<p>΂炭Ԃo߁AL߂Ă܂B<br>萔łAxw葱sĂB</p>),
		same_period_id_error			=> qq(<p>萔łAxw葱sĂB</p>),
		db_access_error101				=> qq(<p>f[^x[XڑɃG[܂B(G[R[hF101)<br>萔łAVbv^c҂ւ₢킹B</p>),
		db_access_error102				=> qq(<p>f[^x[XڑɃG[܂B(G[R[hF102)<br>萔łAVbv^c҂ւ₢킹B</p>),
		db_access_error103				=> qq(<p>f[^x[XڑɃG[܂B(G[R[hF103)<br>萔łAVbv^c҂ւ₢킹B</p>),

		# SBPSpϗpG[R[h(BasketɃ_CNgn)
		sbps_logged_in_error				=> qq(<p>񂪌܂łBisbps_errorj</p>),
		sbps_logged_in_no_approval_member	=> qq(<p>o^FĂ܂Bisbps_errorj</p>),
		sbps_logged_in						=> qq(<p>OCĂ炵΂炭Ԃo߁AOC̗L߂Ă܂B<br>萔łAxOCĂBisbps_errorj</p>),
		sbps_no_member_service				=> qq(<p>݁AT[rX͎gpł܂Bisbps_errorj</p>),
		sbps_only_member_service			=> qq(<p>\\󂲂܂񂪁Aŵ͉qlɌ点ĂĂ܂Bisbps_errorj</p>),
		sbps_no_orderTemp					=> qq(<p>΂炭Ԃo߁AL߂Ă܂B<br>萔łAxw葱sĂBisbps_errorj</p>),
		sbps_same_period_id_error			=> qq(<p>萔łAxw葱sĂBisbps_errorj</p>),
		sbps_db_access_error101				=> qq(<p>f[^x[XڑɃG[܂B(G[R[hF101)<br>萔łAVbv^c҂ւ₢킹Bisbps_errorj</p>),
		sbps_db_access_error102				=> qq(<p>f[^x[XڑɃG[܂B(G[R[hF102)<br>萔łAVbv^c҂ւ₢킹Bisbps_errorj</p>),
		sbps_req_method_error               => qq(<p>SBPSςɊ܂łB<br />\\bhsłBisbps_errorj</p>),
		sbps_common_error					=> qq(<p>SBPSςɊ܂łB</p>),
	);

	my $error_code = shift @_;
	return ( exists $ErrorMessageHash{$error_code} )? $ErrorMessageHash{$error_code}: qq();
}





































































































































